Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4826)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4827)
@@ -1314,9 +1065,9 @@
       CASE ('coupled')
          IF ( TRIM(sn_rcv_dqnsdt%clcat) == 'yes' ) THEN
-            dqns_ice(:,:,1:jpl) = frcv(jpr_dqnsdt)%z3(:,:,1:jpl)
+            dqns_ice(:,:,1:jpl) = sf(jp_dqnsdt)%fnow(:,:,1:jpl)
          ELSE
             ! Set all category values equal for the moment
             DO jl=1,jpl
-               dqns_ice(:,:,jl) = frcv(jpr_dqnsdt)%z3(:,:,1)
+               dqns_ice(:,:,jl) = sf(jp_dqnsdt)%fnow(:,:,1)
             ENDDO
          ENDIF
@@ -1325,6 +1076,6 @@
       SELECT CASE( TRIM( sn_rcv_iceflx%cldes ) )
       CASE ('coupled')
-         topmelt(:,:,:)=frcv(jpr_topm)%z3(:,:,:)
-         botmelt(:,:,:)=frcv(jpr_botm)%z3(:,:,:)
+         topmelt(:,:,:)=sf(jp_topm)%fnow(:,:,:)
+         botmelt(:,:,:)=sf(jp_botm)%fnow(:,:,:)
       END SELECT
 
Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcflx.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 4826)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 4827)
@@ -17,5 +17,7 @@
    USE sbcdcy          ! surface boundary condition: diurnal cycle on qsr
    USE phycst          ! physical constants
-   USE fldread         ! read input fields
+   USE fldread2        ! read input fields
+   USE fld_def
+   USE sbcget
    USE iom             ! IOM library
    USE in_out_manager  ! I/O manager
@@ -27,12 +29,4 @@
 
    PUBLIC sbc_flx       ! routine called by step.F90
-
-   INTEGER , PARAMETER ::   jpfld   = 5   ! maximum number of files to read 
-   INTEGER , PARAMETER ::   jp_utau = 1   ! index of wind stress (i-component) file
-   INTEGER , PARAMETER ::   jp_vtau = 2   ! index of wind stress (j-component) file
-   INTEGER , PARAMETER ::   jp_qtot = 3   ! index of total (non solar+solar) heat file
-   INTEGER , PARAMETER ::   jp_qsr  = 4   ! index of solar heat file
-   INTEGER , PARAMETER ::   jp_emp  = 5   ! index of evaporation-precipation file
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf    ! structure of input fields (file informations, fields read)
 
    !! * Substitutions
@@ -76,5 +70,4 @@
       !!
       INTEGER  ::   ji, jj, jf            ! dummy indices
-      INTEGER  ::   ierror                ! return error code
       REAL(wp) ::   zfact                 ! temporary scalar
       REAL(wp) ::   zrhoa  = 1.22         ! Air density kg/m3
@@ -82,44 +75,13 @@
       REAL(wp) ::   ztx, zty, zmod, zcoef ! temporary variables
       !!
-      CHARACTER(len=100) ::  cn_dir                               ! Root directory for location of flx files
-      TYPE(FLD_N), DIMENSION(jpfld) ::   slf_i                    ! array of namelist information structures
-      TYPE(FLD_N) ::   sn_utau, sn_vtau, sn_qtot, sn_qsr, sn_emp  ! informations about the fields to be read
-      NAMELIST/namsbc_flx/ cn_dir, sn_utau, sn_vtau, sn_qtot, sn_qsr, sn_emp
+!      CHARACTER(len=100) ::  cn_dir                               ! Root directory for location of flx files
+!      NAMELIST/namsbc_flx/ cn_dir, sn_utau, sn_vtau, sn_qtot, sn_qsr, sn_emp
       !!---------------------------------------------------------------------
       !
       IF( kt == nit000 ) THEN                ! First call kt=nit000  
-         ! set file information
-         cn_dir = './'        ! directory in which the model is executed
-         ! ... default values (NB: frequency positive => hours, negative => months)
-         !              !  file   ! frequency !  variable  ! time intep !  clim   ! 'yearly' or ! weights  ! rotation  !
-         !              !  name   !  (hours)  !   name     !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs     !
-         sn_utau = FLD_N(  'utau' ,    24     ,  'utau'    ,  .false.   , .false. ,   'yearly'  , ''       , ''        )
-         sn_vtau = FLD_N(  'vtau' ,    24     ,  'vtau'    ,  .false.   , .false. ,   'yearly'  , ''       , ''        )
-         sn_qtot = FLD_N(  'qtot' ,    24     ,  'qtot'    ,  .false.   , .false. ,   'yearly'  , ''       , ''        )
-         sn_qsr  = FLD_N(  'qsr'  ,    24     ,  'qsr'     ,  .false.   , .false. ,   'yearly'  , ''       , ''        )
-         sn_emp  = FLD_N(  'emp'  ,    24     ,  'emp'     ,  .false.   , .false. ,   'yearly'  , ''       , ''        )
-         !
-         REWIND ( numnam )                         ! read in namlist namflx
-         READ   ( numnam, namsbc_flx ) 
          !
          !                                         ! check: do we plan to use ln_dm2dc with non-daily forcing?
-         IF( ln_dm2dc .AND. sn_qsr%nfreqh /= 24 )   &
+         IF( ln_dm2dc .AND. sf(jp_qsroce)%nfreqh /= 24 )   &
             &   CALL ctl_stop( 'sbc_blk_core: ln_dm2dc can be activated only with daily short-wave forcing' ) 
-         !
-         !                                         ! store namelist information in an array
-         slf_i(jp_utau) = sn_utau   ;   slf_i(jp_vtau) = sn_vtau
-         slf_i(jp_qtot) = sn_qtot   ;   slf_i(jp_qsr ) = sn_qsr 
-         slf_i(jp_emp ) = sn_emp
-         !
-         ALLOCATE( sf(jpfld), STAT=ierror )        ! set sf structure
-         IF( ierror > 0 ) THEN   
-            CALL ctl_stop( 'sbc_flx: unable to allocate sf structure' )   ;   RETURN  
-         ENDIF
-         DO ji= 1, jpfld
-            ALLOCATE( sf(ji)%fnow(jpi,jpj,1) )
-            IF( slf_i(ji)%ln_tint ) ALLOCATE( sf(ji)%fdta(jpi,jpj,1,2) )
-         END DO
-         !                                         ! fill sf with slf_i and control print
-         CALL fld_fill( sf, slf_i, cn_dir, 'sbc_flx', 'flux formulation for ocean surface boundary condition', 'namsbc_flx' )
          !
          sfx(:,:) = 0.0_wp                         ! salt flux due to freezing/melting (non-zero only if ice is present; set in limsbc(_2).F90)
@@ -127,18 +89,16 @@
       ENDIF
 
-      CALL fld_read( kt, nn_fsbc, sf )                            ! input fields provided at the current time-step
-     
       IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN                        ! update ocean fluxes at each SBC frequency
 
-         IF( ln_dm2dc ) THEN   ;   qsr(:,:) = sbc_dcy( sf(jp_qsr)%fnow(:,:,1) )   ! modify now Qsr to include the diurnal cycle
-         ELSE                  ;   qsr(:,:) =          sf(jp_qsr)%fnow(:,:,1)
+         IF( ln_dm2dc ) THEN   ;   qsr(:,:) = sbc_dcy( sf(jp_qsroce)%fnow(:,:,1) )   ! modify now Qsr to include the diurnal cycle
+         ELSE                  ;   qsr(:,:) =          sf(jp_qsroce)%fnow(:,:,1)
          ENDIF
 !CDIR COLLAPSE
          DO jj = 1, jpj                                           ! set the ocean fluxes from read fields
             DO ji = 1, jpi
-               utau(ji,jj) = sf(jp_utau)%fnow(ji,jj,1)
-               vtau(ji,jj) = sf(jp_vtau)%fnow(ji,jj,1)
-               qns (ji,jj) = sf(jp_qtot)%fnow(ji,jj,1) - sf(jp_qsr)%fnow(ji,jj,1)
-               emp (ji,jj) = sf(jp_emp )%fnow(ji,jj,1)
+               utau(ji,jj) = sf(jp_otx1)%fnow(ji,jj,1)
+               vtau(ji,jj) = sf(jp_oty1)%fnow(ji,jj,1)
+               qns (ji,jj) = sf(jp_qtot)%fnow(ji,jj,1) - sf(jp_qsroce)%fnow(ji,jj,1)
+               emp (ji,jj) = sf(jp_oemp )%fnow(ji,jj,1)
             END DO
          END DO
@@ -165,7 +125,7 @@
             WRITE(numout,*) '        read daily momentum, heat and freshwater fluxes OK'
             DO jf = 1, jpfld
-               IF( jf == jp_utau .OR. jf == jp_vtau )   zfact =     1.
-               IF( jf == jp_qtot .OR. jf == jp_qsr  )   zfact =     0.1
-               IF( jf == jp_emp                     )   zfact = 86400.
+               IF( jf == jp_otx1 .OR. jf == jp_oty1   )   zfact =     1.
+               IF( jf == jp_qtot .OR. jf == jp_qsroce )   zfact =     0.1
+               IF( jf == jp_oemp                       )   zfact = 86400.
                WRITE(numout,*) 
                WRITE(numout,*) ' day: ', ndastp , TRIM(sf(jf)%clvar), ' * ', zfact
Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcget.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcget.F90	(revision 4827)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcget.F90	(revision 4827)
@@ -0,0 +1,128 @@
+MODULE sbcget
+   !!======================================================================
+   !!                       ***  MODULE  sbcget  ***
+   !! Ocean forcing:  get input field for surface boundary condition
+   !!=====================================================================
+
+   !!----------------------------------------------------------------------
+   !!   fld_read      : read input fields used for the computation of the
+   !!                   surface boundary condition
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE phycst          ! ???
+   USE in_out_manager  ! I/O manager
+   USE iom             ! I/O manager library
+   USE lib_mpp         ! MPP library
+   USE wrk_nemo        ! work arrays
+   USE timing
+   USE fldread2
+   USE fld_def
+   USE sbc_ice
+#if defined key_cice
+   USE ice_domain_size, only: ncat
+#endif
+   USE cpl_oasis3      ! OASIS3 coupling
+
+   IMPLICIT NONE
+   PRIVATE   
+
+   PUBLIC  sbc_get_init, sbc_get
+
+#if defined key_cice
+   INTEGER, PUBLIC, PARAMETER ::   jpl = ncat 
+#elif ! defined key_lim2   &&   ! defined key_lim3
+   INTEGER, PUBLIC, PARAMETER ::   jpl = 1 
+#endif
+
+   TYPE(FLD), PUBLIC, ALLOCATABLE, DIMENSION(:) ::   sf   ! structure of input fields (file informations, fields read)
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id: fldread.F90 3851 2013-03-27 10:03:54Z smasson $
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE sbc_get_init(  )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE sbc_get_init  ***
+      !!
+      !! ** Purpose :  - read namelists, initialise stuff
+      !!----------------------------------------------------------------------
+      TYPE(FLD_N) ::   sn_wndi, sn_wndj, sn_otx1, sn_oty1, sn_otz1, sn_otx2, sn_oty2, sn_otz2,  sn_itx1, sn_ity1, sn_itz1, sn_itx2, sn_ity2, sn_itz2
+      TYPE(FLD_N) ::   sn_qsroce, sn_qnsoce, sn_qlw, sn_tair, sn_humi, sn_prec, sn_rain, sn_snow, sn_tevp, sn_ievp, sn_tdif, sn_w10m, sn_qtot
+      TYPE(FLD_N) ::   sn_oemp, sn_rnf, sn_cal, sn_topm, sn_botm, sn_qsrice, sn_qsrmix, sn_qnsice, sn_qnsmix, sn_taum, sn_sbpr, sn_semp, sn_dqnsdt, sn_co2
+      TYPE(FLD_N), DIMENSION(jpfld) ::   slf_i
+      INTEGER ::   jn       ! dummy loop index
+      INTEGER ::   ierror   ! return error code
+      CHARACTER(len=100) ::  cn_dir   !   Root directory for location of core files
+      NAMELIST/namsbc_get/ cn_dir , sn_wndi, sn_wndj, sn_otx1, sn_oty1, sn_otz1, sn_otx2, sn_oty2, sn_otz2,  sn_itx1, sn_ity1, sn_itz1, sn_itx2, sn_ity2, sn_itz2, sn_qsroce, sn_qnsoce, sn_qlw, sn_tair, sn_humi, sn_prec, sn_rain, sn_snow, sn_tevp, sn_ievp, sn_tdif, sn_w10m, sn_qtot, sn_oemp, sn_rnf, sn_cal, sn_topm, sn_botm, sn_qsrice, sn_qsrmix, sn_qnsice, sn_qnsmix, sn_taum, sn_sbpr, sn_semp, sn_dqnsdt, sn_co2
+      !!---------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('sbc_get_init')
+
+      ! set file information (default values)
+      cn_dir = './'       ! directory in which the model is executed
+
+      REWIND( numnam )                    ! ... read namlist namsbc_get
+      READ  ( numnam, namsbc_get )
+
+      slf_i(jp_wndi) = sn_wndi     ;   slf_i(jp_wndj) = sn_wndj
+      slf_i(jp_otx1) = sn_otx1     ;   slf_i(jp_oty1) = sn_oty1     ;  slf_i(jp_otz1) = sn_otz1
+      slf_i(jp_otx2) = sn_otx2     ;   slf_i(jp_oty2) = sn_oty2     ;  slf_i(jp_otz2) = sn_otz2
+      slf_i(jp_itx1) = sn_itx1     ;   slf_i(jp_ity1) = sn_ity1     ;  slf_i(jp_itz1) = sn_itz1
+      slf_i(jp_itx1) = sn_itx2     ;   slf_i(jp_ity2) = sn_ity2     ;  slf_i(jp_itz2) = sn_itz2
+      slf_i(jp_qsroce) = sn_qsroce ;   slf_i(jp_qsrice) = sn_qsrice ;  slf_i(jp_qsrmix) = sn_qsrmix 
+      slf_i(jp_qnsoce) = sn_qnsoce ;   slf_i(jp_qnsice) = sn_qnsice ;  slf_i(jp_qnsmix) = sn_qnsmix 
+      slf_i(jp_qlw)  = sn_qlw      ;   slf_i(jp_tair) = sn_tair     ;  slf_i(jp_humi) = sn_humi 
+      slf_i(jp_prec) = sn_prec     ;   slf_i(jp_rain) = sn_rain     ;  slf_i(jp_snow) = sn_snow      
+      slf_i(jp_tevp) = sn_tevp     ;   slf_i(jp_ievp) = sn_ievp     ;  slf_i(jp_tdif) = sn_tdif
+      slf_i(jp_taum) = sn_taum     ;   slf_i(jp_w10m) = sn_w10m     ;  slf_i(jp_qtot) = sn_qtot
+      slf_i(jp_sbpr) = sn_sbpr     ;   slf_i(jp_semp) = sn_semp     ;  slf_i(jp_oemp) = sn_oemp     
+      slf_i(jp_rnf)  = sn_rnf      ;   slf_i(jp_cal)  = sn_cal      ;  slf_i(jp_topm) = sn_topm
+      slf_i(jp_botm) = sn_botm     ;   slf_i(jp_dqnsdt) = sn_dqnsdt ;  slf_i(jp_co2) = sn_co2
+
+      ALLOCATE( sf(jpfld), STAT=ierror )         ! set sf structure
+      IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_cpl: unable to allocate sf structure' )
+
+      CALL fld_fill2( sf, slf_i, jpl, cn_dir, 'sbc_get', 'coupled formulation for ocean surface boundary condition', 'namsbc_get' )
+
+      ! Allocate all parts of sf used for received fields
+      DO jn = 1, jpfld
+         IF ( sf(jn)%loasis .OR. sf(jn)%lfile ) ALLOCATE( sf(jn)%fnow(jpi,jpj,sf(jn)%nct) )
+         IF ( sf(jn)%lfile .AND. sf(jn)%ln_tint ) ALLOCATE( sf(jn)%fdta(jpi,jpj,sf(jn)%nct,2) )
+      END DO
+
+      ! Allocate taum part of sf which is used even when not received as coupling field
+      IF ( .NOT. sf(jp_taum)%loasis ) ALLOCATE( sf(jp_taum)%fnow(jpi,jpj,sf(jn)%nct) )
+
+! **WE REALLY NEED A WHOLE LOAD OF CHECKS THAT NAMSBC_GET IS CONSISTENT WITH OTHER CHOICES RE COUPLED / BULK ETC  BUT DO THIS LATER** ! **MAY REQUIRE CHANGES TO OTHER NAME-LIST STRUCTURES** !
+
+      IF( nn_timing == 1 )  CALL timing_stop('sbc_get_init')
+
+   END SUBROUTINE sbc_get_init
+
+   SUBROUTINE sbc_get( kt )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE sbc_get  ***
+      !!
+      !! ** Purpose :   get the data
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt       ! ocean model time step index
+      INTEGER ::   jn       ! dummy loop index
+      INTEGER  ::   isec                   ! number of seconds since nit000 (assuming rdttra did not change since nit000)
+
+      isec = ( kt - nit000 ) * NINT( rdttra(1) )             ! date of exchanges
+
+      DO jn= 1, jpfld
+         IF( sf(jn)%lfile )  CALL fld_read2( kt, nn_fsbc, sf(jn:jn) )  ! input fields provided at the current time-step
+         IF( sf(jn)%loasis )  CALL cpl_prism_rcv( isec, sf(jn) )        ! input fields provided at the current time-step
+      END DO
+
+! Need to sort out where / how rotation should work....
+      CALL fld_rot2( kt, sf )                    ! rotate vector before/now/after fields if needed
+
+   END SUBROUTINE sbc_get
+
+END MODULE sbcget
Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 4826)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 4827)
@@ -22,5 +22,5 @@
    USE timing          ! Timing
    USE daymod          ! calendar
-   USE fldread         ! read input fields
+   USE fld_def
 
    USE sbc_oce         ! Surface boundary condition: ocean fields
@@ -28,4 +28,5 @@
    USE sbcblk_core     ! Surface boundary condition: CORE bulk
    USE sbccpl
+   USE sbcget
 
    USE ice_kinds_mod
@@ -62,20 +63,4 @@
    INTEGER , PARAMETER ::   ji_off = INT ( (jpiglo - nx_global) / 2 )
    INTEGER , PARAMETER ::   jj_off = INT ( (jpjglo - ny_global) / 2 )
-
-   INTEGER , PARAMETER ::   jpfld   = 13   ! maximum number of files to read 
-   INTEGER , PARAMETER ::   jp_snow = 1    ! index of snow file
-   INTEGER , PARAMETER ::   jp_rain = 2    ! index of rain file
-   INTEGER , PARAMETER ::   jp_sblm = 3    ! index of sublimation file
-   INTEGER , PARAMETER ::   jp_top1 = 4    ! index of category 1 topmelt file
-   INTEGER , PARAMETER ::   jp_top2 = 5    ! index of category 2 topmelt file
-   INTEGER , PARAMETER ::   jp_top3 = 6    ! index of category 3 topmelt file
-   INTEGER , PARAMETER ::   jp_top4 = 7    ! index of category 4 topmelt file
-   INTEGER , PARAMETER ::   jp_top5 = 8    ! index of category 5 topmelt file
-   INTEGER , PARAMETER ::   jp_bot1 = 9    ! index of category 1 botmelt file
-   INTEGER , PARAMETER ::   jp_bot2 = 10   ! index of category 2 botmelt file
-   INTEGER , PARAMETER ::   jp_bot3 = 11   ! index of category 3 botmelt file
-   INTEGER , PARAMETER ::   jp_bot4 = 12   ! index of category 4 botmelt file
-   INTEGER , PARAMETER ::   jp_bot5 = 13   ! index of category 5 botmelt file
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf    ! structure of input fields (file informations, fields read)
 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:), PRIVATE ::   png     ! local array used in sbc_cice_ice
@@ -655,5 +640,5 @@
       IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)'cice_sbc_hadgam'
-         IF( sbc_cpl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_cpl_alloc : unable to allocate arrays' )
+!         IF( sbc_cpl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_cpl_alloc : unable to allocate arrays' )
       ENDIF
 
@@ -705,5 +690,5 @@
       !!
       !!---------------------------------------------------------------------
-      !! ** Method  :   READ monthly flux file in NetCDF files
+      !! ** Method  :   Set forcing fields
       !!      
       !!  snowfall    
@@ -716,75 +701,8 @@
       !!----------------------------------------------------------------------
       !! * Modules used
-      USE iom
-
-      !! * arguments
+
       INTEGER, INTENT( in  ) ::   kt ! ocean time step
 
-      INTEGER  ::   ierror             ! return error code
-      INTEGER  ::   ifpr               ! dummy loop index
-      !!
-      CHARACTER(len=100) ::  cn_dir                            !   Root directory for location of CICE forcing files
-      TYPE(FLD_N), DIMENSION(jpfld) ::   slf_i                 ! array of namelist informations on the fields to read
-      TYPE(FLD_N) ::   sn_snow, sn_rain, sn_sblm               ! informations about the fields to be read
-      TYPE(FLD_N) ::   sn_top1, sn_top2, sn_top3, sn_top4, sn_top5
-      TYPE(FLD_N) ::   sn_bot1, sn_bot2, sn_bot3, sn_bot4, sn_bot5 
-
-      !!
-      NAMELIST/namsbc_cice/ cn_dir, sn_snow, sn_rain, sn_sblm,   &
-         &                          sn_top1, sn_top2, sn_top3, sn_top4, sn_top5,  &
-         &                          sn_bot1, sn_bot2, sn_bot3, sn_bot4, sn_bot5
-      !!---------------------------------------------------------------------
-
-      !                                         ! ====================== !
-      IF( kt == nit000 ) THEN                   !  First call kt=nit000  !
-         !                                      ! ====================== !
-         ! set file information (default values)
-         cn_dir = './'       ! directory in which the model is executed
-
-         ! (NB: frequency positive => hours, negative => months)
-         !            !    file          ! frequency !  variable    ! time intep !  clim   ! 'yearly' or ! weights  ! rotation   !
-         !            !    name          !  (hours)  !   name       !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs      !
-         sn_snow = FLD_N( 'snowfall_1m'  ,    -1.    ,  'snowfall'  ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         ) 
-         sn_rain = FLD_N( 'rainfall_1m'  ,    -1.    ,  'rainfall'  ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         ) 
-         sn_sblm = FLD_N( 'sublim_1m'    ,    -1.    ,  'sublim'    ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_top1 = FLD_N( 'topmeltn1_1m' ,    -1.    ,  'topmeltn1' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_top2 = FLD_N( 'topmeltn2_1m' ,    -1.    ,  'topmeltn2' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_top3 = FLD_N( 'topmeltn3_1m' ,    -1.    ,  'topmeltn3' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_top4 = FLD_N( 'topmeltn4_1m' ,    -1.    ,  'topmeltn4' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_top5 = FLD_N( 'topmeltn5_1m' ,    -1.    ,  'topmeltn5' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_bot1 = FLD_N( 'botmeltn1_1m' ,    -1.    ,  'botmeltn1' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_bot2 = FLD_N( 'botmeltn2_1m' ,    -1.    ,  'botmeltn2' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_bot3 = FLD_N( 'botmeltn3_1m' ,    -1.    ,  'botmeltn3' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_bot4 = FLD_N( 'botmeltn4_1m' ,    -1.    ,  'botmeltn4' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-         sn_bot5 = FLD_N( 'botmeltn5_1m' ,    -1.    ,  'botmeltn5' ,  .true.    , .true.  ,  ' yearly'  , ''       , ''         )
-
-!         REWIND ( numnam )               ! ... at some point might read in from NEMO namelist?
-!         READ   ( numnam, namsbc_cice ) 
-
-         ! store namelist information in an array
-         slf_i(jp_snow) = sn_snow   ;   slf_i(jp_rain) = sn_rain   ;   slf_i(jp_sblm) = sn_sblm
-         slf_i(jp_top1) = sn_top1   ;   slf_i(jp_top2) = sn_top2   ;   slf_i(jp_top3) = sn_top3
-         slf_i(jp_top4) = sn_top4   ;   slf_i(jp_top5) = sn_top5   ;   slf_i(jp_bot1) = sn_bot1
-         slf_i(jp_bot2) = sn_bot2   ;   slf_i(jp_bot3) = sn_bot3   ;   slf_i(jp_bot4) = sn_bot4
-         slf_i(jp_bot5) = sn_bot5
-         
-         ! set sf structure
-         ALLOCATE( sf(jpfld), STAT=ierror )
-         IF( ierror > 0 ) THEN
-            CALL ctl_stop( 'cice_sbc_force: unable to allocate sf structure' )   ;   RETURN
-         ENDIF
-
-         DO ifpr= 1, jpfld
-            ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1) )
-            ALLOCATE( sf(ifpr)%fdta(jpi,jpj,1,2) )
-         END DO
-
-         ! fill sf with slf_i and control print
-         CALL fld_fill( sf, slf_i, cn_dir, 'cice_sbc_force', 'flux formulation for CICE', 'namsbc_cice' )
-         !
-      ENDIF
-
-      CALL fld_read( kt, nn_fsbc, sf )           ! Read input fields and provides the
-      !                                          ! input fields at the current time-step
+      ! Assume the fluxes have already been obtained somewhere....
 
       ! set the fluxes from read fields
@@ -792,22 +710,7 @@
       tprecip(:,:) = sf(jp_snow)%fnow(:,:,1)+sf(jp_rain)%fnow(:,:,1)
 ! May be better to do this conversion somewhere else
-      qla_ice(:,:,1) = -Lsub*sf(jp_sblm)%fnow(:,:,1)
-      topmelt(:,:,1) = sf(jp_top1)%fnow(:,:,1)
-      topmelt(:,:,2) = sf(jp_top2)%fnow(:,:,1)
-      topmelt(:,:,3) = sf(jp_top3)%fnow(:,:,1)
-      topmelt(:,:,4) = sf(jp_top4)%fnow(:,:,1)
-      topmelt(:,:,5) = sf(jp_top5)%fnow(:,:,1)
-      botmelt(:,:,1) = sf(jp_bot1)%fnow(:,:,1)
-      botmelt(:,:,2) = sf(jp_bot2)%fnow(:,:,1)
-      botmelt(:,:,3) = sf(jp_bot3)%fnow(:,:,1)
-      botmelt(:,:,4) = sf(jp_bot4)%fnow(:,:,1)
-      botmelt(:,:,5) = sf(jp_bot5)%fnow(:,:,1)
-
-      ! control print (if less than 100 time-step asked)
-      IF( nitend-nit000 <= 100 .AND. lwp ) THEN
-         WRITE(numout,*) 
-         WRITE(numout,*) '        read forcing fluxes for CICE OK'
-         CALL FLUSH(numout)
-      ENDIF
+      qla_ice(:,:,1) = -Lsub*sf(jp_ievp)%fnow(:,:,1)
+      topmelt(:,:,:) = sf(jp_topm)%fnow(:,:,:)
+      botmelt(:,:,:) = sf(jp_botm)%fnow(:,:,:)
 
    END SUBROUTINE cice_sbc_force
Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 4826)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 4827)
@@ -37,4 +37,5 @@
    USE sbcice_cice      ! surface boundary condition: CICE    sea-ice model
    USE sbccpl           ! surface boundary condition: coupled florulation
+   USE sbcget
    USE cpl_oasis3, ONLY:lk_cpl      ! are we in coupled mode?
    USE sbcssr           ! surface boundary condition: sea surface restoring
@@ -221,4 +222,6 @@
       IF( ln_ssr      )   CALL sbc_ssr_init               ! Sea-Surface Restoring initialisation
       !
+      CALL sbc_get_init
+      !
       IF( nn_ice == 4 )   CALL cice_sbc_init( nsbc )      ! CICE initialisation
       !
@@ -258,4 +261,7 @@
          sfx_b(:,:) = sfx(:,:)
       ENDIF
+      !
+      CALL sbc_get( kt )
+      !
       !                                            ! ---------------------------------------- !
       !                                            !        forcing field computation         !
